diff --git a/swaynag/swaynag.c b/swaynag/swaynag.c
index 26d3589e39..69da851e6d 100644
--- a/swaynag/swaynag.c
+++ b/swaynag/swaynag.c
@@ -390,6 +390,10 @@ void swaynag_run(struct swaynag *swaynag) {
 			&& wl_display_dispatch(swaynag->display) != -1) {
 		// This is intentionally left blank
 	}
+
+	if (swaynag->display) {
+		wl_display_disconnect(swaynag->display);
+	}
 }
 
 void swaynag_destroy(struct swaynag *swaynag) {
@@ -449,8 +453,4 @@ void swaynag_destroy(struct swaynag *swaynag) {
 	if (swaynag->shm) {
 		wl_shm_destroy(swaynag->shm);
 	}
-
-	if (swaynag->display) {
-		wl_display_disconnect(swaynag->display);
-	}
 }
